# -*-python-*-

__package__    = "twgrowler.py"
__version__    = "1.0"
__author__     = "Aaron Straup Cope"
__url__        = "http://www.aaronland.info/python/twnotifier/"
__cvsversion__ = "$Revision: 1.3 $"
__date__       = "$Date: 2006/11/25 16:59:56 $"
__copyright__  = "Copyright (c) 2006 Aaron Straup Cope. Perl Artistic License."

from twnotifier import * 
from Growl import *

class twgrowler (twnotifier) :

    def setup_notification_agent(self) :

        self.log("Setting up notification agent")

        try :
            self.__growl__ = GrowlNotifier(applicationName="twgrowler",
                                           notifications=["twgrowl"],
                                           defaultNotifications=["twgrowl"])
        except Exception, e :
            self.error("Failed to create notification agent, %s" % e)
            return False

        try :
            self.__growl__.register()
        except Exception, e :
            self.error("Failed to register notification agent, %s" % e)
            return False

        return True
    
    #
    #
    #
    
    def notify (self, tw) :

        title  = tw['who']
        desc   = self.format_twitter_message(tw)
        
        try :
            self.__growl__.notify("twgrowl", title, desc, None, True)
        except Exception :
            self.error("Failed to notify, %s" % e)
            return False

        return True

    #
    #
    #
    
if __name__ == "__main__" :

    import os.path
    import pwd
    import posix

    user = pwd.getpwuid(posix.geteuid())
    storeroot = os.path.abspath(user[5])
    storepath = os.path.abspath(os.path.join(storeroot, u".twnotifier"))

    app = twgrowler(storepath)
    app.loop()
